<?php 
// VERSION 1 - 22 juillet 2004
// par Coyote
// alias Jean-Pierre KUNTZ

// fonctions pour jouer avec les extras
// Rcupration des extras dj remplis dans la base
//
// Arguments : $id pour le numro de l'objet
//             $objet pour le type d'objet (article, auteur...)
// S'il y a des extra, retourne un tableau associatif, 
// les cls tant le nom de l'extra. Sinon retourne FALSE 
function get_extra ($id, $objet) {
  if(!$id) return false;
  global $table_prefix;  
  // On construit qqch qui ressemble  "SELECT extra FROM spip_articles WHERE id_article=$id_article"
  $query = "SELECT statut, extra FROM ".$table_prefix."_".$objet."s";
  $query .= " WHERE id_".$objet."=".$id;
  $res = spip_query($query);
  $cells = spip_fetch_array($res);
  if(!$cells["extra"]) 
    return false ;
  $extra = unserialize ($cells["extra"]);
  return $extra;
}

// Enregistrement des extras aprs saisie d'un formulaire ou aprs un script php.
// Arguments  
//    id : numro de l'objet
//    extra : TOUS les extra pour l'objet
//    objet : type de l'objet (article, auteur...)
// On testera avec bonheur la valeur de retour
// de cette fonction lors de son appel.
function set_extra ($id, $extra, $objet) {
  if(!$id) return false;
  global $table_prefix;  
  $extra = addslashes(serialize($extra));
  // On construit qqch qui ressemble  "UPDATE spip_articles SET extra='$extra' WHERE id_article=$id_article"
  $query = "UPDATE ".$table_prefix."_".$objet."s";
  $query .= " SET extra='$extra' ";
  $query .= " WHERE id_".$objet."=".$id;
  return spip_query($query);
}

function voir_les_droits($auteur){
  //on deserialise l'extra de l'auteur 
  if(!$extra_auteur=get_extra($auteur,"auteur")){
     return false;
  }else{
    return $extra_auteur['liste_rubrique'];
  }
}
// IMPORTANT : voir le source de jpk_acces_rubriques.php(3) pour l'utilisation

    // Rcupration POST
    $ext      = $HTTP_POST_VARS['ext'];
    $compteur = $HTTP_POST_VARS['compteur'];
    $requete  = $HTTP_POST_VARS['requete'];

// Le filtre sur $compteur sert  viter les fausses manip d'appel direct de ce fichier
if ($compteur){
    include ("inc.$ext"); 
    $req_tous= URLDECODE("$requete");
    $result_tous = spip_query($req_tous);
    $liste = "";
    $compteur2 = 0;
    while ($row_tous = mysql_fetch_array($result_tous)){
        $ID = $row_tous[0];
        $acces = "acces_".$ID;
        $acces_affich = $HTTP_POST_VARS["$acces"];
        $accesoriginal = voir_les_droits($ID);
        if ($accesoriginal != $acces_affich) {
            // On met  jour le champ meta de l'article
            $extra_article['liste_rubrique'] = $acces_affich;
            if (!set_extra($ID, $extra_article, "auteur")) {
            echo "<b> <font color=\"#ff0000\">Erreur sur auteur $ID!</font></b><br>" ;
            }
            $liste .= $ID.",";
            $compteur2++;
        }
    }
    $liste = "(".substr("$liste", 0, -1).")";
    
    // GESTION d'un appui sur Submit sans modification de statut
    if ($compteur2) {    
        $FILTRE = urlencode("WHERE id_auteur in $liste");
        header("Location: jpk_acces_rubriques.$ext?FILTRE=$FILTRE");
    }else{
        header("Location: jpk_acces_rubriques.$ext");
    }
    
}else{ // Appel direct de jpk_acces_rubriques.PHP(3)

    // DETECTION DE L'EXTENSION (.php3 OU .php)
    $ext = "php"; 
    if (substr($HTTP_SERVER_VARS['PHP_SELF'],-1) == 3)  $ext = "php3"; 
    header("Location: jpk_acces_rubriques.$ext");
}
?>